#! ruby -Ks
# f[^e[ȗ݊mFA֘Ȁo
# JgfBNg *.xls 𑍂ă`FbN
require "exlap"

file_list = Dir.glob("./*.xls")
if file_list.size < 1
  exit
end
puts 'f[^e[u֘Ao'
Exlap.new(*file_list) do |wb|
  printf("FileName: %s\n", wb.name)
  empty_names = wb.empty_sheet_names
  wb.each do |ss|  # e[NV[g𒲂ׂ
    next  if empty_names.include?(ss.Name)  # ̃[NV[gXLbv
    printf("WorkSheet: %s\n", ss.Name)
    tbl_ary = ss.finda(/^=table\(/i, 'Formula')  # TABLE֐̃Z𒊏o
    dtbl_count = 0
    while tbl_ary.size > 0
      dtbl_count += 1  # V[gɂf[^e[u̔ԍ
      first_cell = tbl_ary[0]  # ŏTABLE֐L^Z
      tbl_str = first_cell.Formula  # TABLE֐̋̓ILq()
      row_cell = col_cell = nil  # sƗ̑ZɋL^
      if tbl_str =~ /^=table\((.*?),(.*?)\)$/i
        row_cell = $1
        col_cell = $2
      end
          ##
      last_cell = nil  # f[^e[ü̏I_Z
      while tbl_ary.size > 0 and tbl_ary[0].Formula == tbl_str
        last_cell = tbl_ary.shift
      end
      y1,x1 = Exl::yx(first_cell)
      y2,x2 = Exl::yx(last_cell)
      fy = (y1 < y2) ? y1-1 : y1  # vZZyWl
      fx = (x1 < x2) ? x1-1 : x1  # vZZxWl
      if [fy,fx] == [y1,x1]
        if ss.cell(fy-1,fx).Formula != ''
          fy -= 1
        elsif ss.cell(fy,fx-1).Formula != ''
          fx -= 1
        else
          fy = fx = nil
        end
      end
      formula_cell = Exl::a1(ss.cell(fy,fx))  # y,xA1`ɕϊ
      formula = ss.Range(formula_cell).Formula  # vZ()
      if formula =~ /^=([A-Z]+\d+|\$[A-Z]+\$\d+)$/i  # ʃZQƂ̏ꍇ
        w = $1
        formula = ss.Range(w).Formula
      end
          ##
      row_data = []
      unless [fy,fx] == [y1-1,x1]
        (x1..x2).each {|x|  row_data<<ss.cell(y1-1,x).Value}
      end
      col_data = []
      unless [fy,fx] == [y1,x1-1]
        (y1..y2).each {|y|  col_data<<ss.cell(y,x1-1).Value}
      end
          ##
      printf("f[^e[u #%d\n", dtbl_count)
      printf("s̑Z: %s\n", row_cell)  if row_cell.to_s != ''
      printf("̑Z: %s\n", col_cell)  if col_cell.to_s != ''
      printf("vZ̃ZԒn: %s\n", formula_cell)
      printf("vZ: %s\n", formula)
      if row_data.size > 0
        printf("sf[^(): ")
        p row_data
      end
      if col_data.size > 0
        printf("f[^(c): ")
        p col_data
      end
      printf("\n")  if tbl_ary.size > 0
    end
    printf("\n")
  end
  wb.close
end
